param
(
	[Parameter(Mandatory=$true)]
	[string]$vmName
)

$ErrorActionPreference = "Stop"


# Check if VM exists
$vm = Get-VM $vmName -ErrorAction SilentlyContinue
if (-not $vm) {
    return
}


# Turn off
try {
	Stop-VM -Name $vmName -TurnOff
}
catch {
	Write-Host "Cannot turn off VM: $($_.Exception.Message)"
	exit 1
}



# Delete VM

try {
	Remove-VM -Name $vmName -Force
}
catch {
	Write-Host "Error deleting VM: $($_.Exception.Message)"
	exit 1
}


