param
(
	[Parameter(Mandatory=$true)]
	[string]$vmName,

	[Parameter(Mandatory=$true)]
	[int]$maxIOPS
)

$ErrorActionPreference = "Stop"


# Update IOPs
try {
	Set-VMHardDiskDrive -VMName $vmName -ControllerType IDE -ControllerNumber 0 -ControllerLocation 0 -MaximumIOPS $maxIOPS
}
catch {
	Write-Host "Error updating VM hard disk IOPs: $($_.Exception.Message)"
	exit 1
}

